Bug 158198 - AX: iOS: VoiceOver can't access attachments in mail messages
Summary: AX: iOS: VoiceOver can't access attachments in mail messages
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: Accessibility (show other bugs)
Version: Safari 9
Hardware: All All
: P2 Normal
Assignee: chris fleizach
URL:
Keywords: InRadar
Depends on:
Blocks:
 
Reported: 2016-05-30 00:20 PDT by chris fleizach
Modified: 2016-06-01 17:24 PDT (History)
9 users (show)

See Also:


Attachments
Patch (8.19 KB, patch)
2016-05-30 00:31 PDT, chris fleizach
no flags Details | Formatted Diff | Diff
Patch (9.54 KB, patch)
2016-05-31 12:51 PDT, chris fleizach
buildbot: commit-queue-
Details | Formatted Diff | Diff
Archive of layout-test-results from ews126 for ios-simulator-wk2 (699.38 KB, application/zip)
2016-05-31 13:46 PDT, Build Bot
no flags Details
Patch (11.25 KB, patch)
2016-06-01 11:39 PDT, chris fleizach
no flags Details | Formatted Diff | Diff
Patch (9.98 KB, patch)
2016-06-01 11:40 PDT, chris fleizach
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description chris fleizach 2016-05-30 00:20:49 PDT
VoiceOver is not able to access attributed strings with attachments in them on iOS

<rdar://problem/26523054>
Comment 1 chris fleizach 2016-05-30 00:31:40 PDT
Created attachment 280075 [details]
Patch

There's no expected file right now. Couldn't make simulator run for me. Hoping build bots produce expected result
Comment 2 chris fleizach 2016-05-31 12:51:10 PDT
Created attachment 280169 [details]
Patch
Comment 3 chris fleizach 2016-05-31 12:51:43 PDT
Joanmarie: ready for review if you have a chance
Comment 4 Build Bot 2016-05-31 13:46:02 PDT
Comment on attachment 280169 [details]
Patch

Attachment 280169 [details] did not pass ios-sim-ews (ios-simulator-wk2):
Output: http://webkit-queues.webkit.org/results/1413955

New failing tests:
accessibility/ios-simulator/attributed-string-for-range.html
Comment 5 Build Bot 2016-05-31 13:46:05 PDT
Created attachment 280174 [details]
Archive of layout-test-results from ews126 for ios-simulator-wk2

The attached test failures were seen while running run-webkit-tests on the ios-sim-ews.
Bot: ews126  Port: ios-simulator-wk2  Platform: Mac OS X 10.11.4
Comment 6 chris fleizach 2016-05-31 16:44:09 PDT
(In reply to comment #5)
> Created attachment 280174 [details]
> Archive of layout-test-results from ews126 for ios-simulator-wk2
> 
> The attached test failures were seen while running run-webkit-tests on the
> ios-sim-ews.
> Bot: ews126  Port: ios-simulator-wk2  Platform: Mac OS X 10.11.4

Ah, debug vs. Release
-(NSString *)description not implemented in release
Comment 7 chris fleizach 2016-06-01 11:39:20 PDT
Created attachment 280251 [details]
Patch
Comment 8 chris fleizach 2016-06-01 11:40:17 PDT
Created attachment 280252 [details]
Patch
Comment 9 Joanmarie Diggs 2016-06-01 13:46:00 PDT
Comment on attachment 280252 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=280252&action=review

> Source/WebCore/ChangeLog:8
> +        Replaced elements, like attachemnts, were not being exposed in the attributed string returned to VoiceOver.

nit: attachments

> Source/WebCore/accessibility/ios/WebAccessibilityObjectWrapperIOS.mm:65
> +    NSAttachmentCharacter = 0xfffc    /* To denote attachments. */

It looks like this will be the third place this character is being defined (the other two being editing/cocoa/HTMLConverter.mm and platform/mac/WebNSAttributedStringExtras.mm). Would it make sense to define it once in a platform header?
Comment 10 WebKit Commit Bot 2016-06-01 14:25:45 PDT
Comment on attachment 280252 [details]
Patch

Clearing flags on attachment: 280252

Committed r201568: <http://trac.webkit.org/changeset/201568>
Comment 11 WebKit Commit Bot 2016-06-01 14:25:50 PDT
All reviewed patches have been landed.  Closing bug.
Comment 12 chris fleizach 2016-06-01 17:24:21 PDT
(In reply to comment #9)
> Comment on attachment 280252 [details]
> Patch
> 
> View in context:
> https://bugs.webkit.org/attachment.cgi?id=280252&action=review
> 
> > Source/WebCore/ChangeLog:8
> > +        Replaced elements, like attachemnts, were not being exposed in the attributed string returned to VoiceOver.
> 
> nit: attachments
> 
> > Source/WebCore/accessibility/ios/WebAccessibilityObjectWrapperIOS.mm:65
> > +    NSAttachmentCharacter = 0xfffc    /* To denote attachments. */
> 
> It looks like this will be the third place this character is being defined
> (the other two being editing/cocoa/HTMLConverter.mm and
> platform/mac/WebNSAttributedStringExtras.mm). Would it make sense to define
> it once in a platform header?

https://bugs.webkit.org/show_bug.cgi?id=158287